/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2010
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   image_sensor_SP0821_SERIAL.c  V1.0
 *
 * Project:
 * --------
 *   Maui_sw
 *
 * Description:
 * ------------
 *   Image sensor driver function
 *
 * Author:
 * -------
 *   superpix lcg.
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 * $Revision:$
 * $Modtime:$
 * $Log:$
 *
 *
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#include "drv_comm.h"
#include "isp_comm_if.h"
#include "camera_sccb.h"
#include "image_sensor.h"
#include "cal_comm_def.h"
#include "isp_if.h"


#if defined(DUAL_CAMERA_SUPPORT)
extern kal_bool camera_front_or_back;
#endif
#define  SP0821_DAYLIGHT_MAXGAIN             0xc0
#define  SP0821_NIGHT_MAXGAIN                0xc0

static struct
{
  kal_bool BypassAe;
  kal_bool BypassAwb;
  
  kal_bool CapState; /* KAL_TRUE: in capture state, else in preview state */
  kal_bool PvMode; /* KAL_TRUE: in preview mode, else in capture mode */
  kal_uint8 BandingFreq; /* SP0821_SERIAL_50HZ or SP0821_SERIAL_60HZ for 50Hz/60Hz */
  
  kal_uint32 InternalClock; /* internal clock which using process pixel(for exposure) */
  kal_uint32 Pclk; /* output clock which output to baseband */
  kal_uint32 Gain; /* base on 0x40 */
  kal_uint32 Shutter; /* unit is (linelength / internal clock) s */
  
  kal_uint32 FrameLength; /* total line numbers in one frame(include dummy line) */
  kal_uint32 LineLength; /* total pixel numbers in one line(include dummy pixel) */
  
  IMAGE_SENSOR_INDEX_ENUM SensorIdx;
  sensor_data_struct *NvramData;
  
  kal_uint16 MinFrameRate;	/* 150 means 15.0fps. */
  kal_uint16 MaxFrameRate;	/* 300 means 30.0fps. */
  
  kal_uint32 dummy_lines;
  kal_uint32 dummy_pixels;
  
  kal_uint32 curr_frame_time;	/* It's get from the TG Int. */
	
  kal_bool sccb_opened;			/* The I2C can work when sccb_opened is KAL_TRUE */
} SP0821_SERIALSensor;

kal_bool video_mode = KAL_FALSE;
kal_uint8 SP0821_SERIAL_CAM_BANDING_50HZ = CAM_BANDING_60HZ;
kal_bool SP0821_SERIAL_CAM_nightmode = KAL_FALSE;

kal_bool RD_Tcard_OK = KAL_FALSE;	//add by sp_yjp,20171031

//#define SP0821_LOAD_FROM_T_FLASH	//T-card for camera debug on/off
#ifdef SP0821_LOAD_FROM_T_FLASH
/*************************************************************************
* FUNCTION
*  SP0821_Initialize_from_T_Flash
*
* DESCRIPTION
*  Read the initialize setting from t-flash or user disk to speed up image quality tuning.
*
* PARAMETERS
*  None
*
* RETURNS
*  kal_uint8 - 0 : Load setting fail, 1 : Load setting successfully.
*
*************************************************************************/
static kal_uint8 SP0821_Initialize_from_T_Flash()
{
#include <stdlib.h>
#include "med_utility.h"
#include "fs_type.h"
#include "app_mem.h"

    /* 0 - Initial value, 1 - Register, 2 - Delay, 3 - End of setting. */
    #define SP0821_OP_CODE_INI    0x00    /* Initial value. */
    #define SP0821_OP_CODE_REG    0x01    /* Register */
    #define SP0821_OP_CODE_DLY    0x02    /* Delay */
    #define SP0821_OP_CODE_END    0x03    /* End of initial setting. */
    typedef struct
    {
        kal_uint16 init_reg;
        kal_uint16 init_val;  /* Save the register value and delay tick */
        kal_uint8 op_code;    /* 0 - Initial value, 1 - Register, 2 - Delay, 3 - End of setting. */
    } SP0821_initial_set_struct;
    SP0821_initial_set_struct SP0821_Init_Reg[1000];	
    static WCHAR SP0821_set_file_name[256] = {0};
    FS_HANDLE fp = -1;        /* Default, no file opened. */
    kal_uint8 *data_buff = NULL;
    kal_uint8 *curr_ptr = NULL;
    kal_uint32 file_size = 0;
    kal_uint32 bytes_read = 0;
    kal_uint32 i = 0, j = 0;
    kal_uint8 func_ind[3] = {0};  /* REG or DLY */
    kal_mem_cpy(SP0821_set_file_name, L"C:\\sp0821_sd.dat", sizeof(L"C:\\sp0821_sd.dat"));
    /* Search the setting file in all of the user disk. */
    curr_ptr = (kal_uint8 *)SP0821_set_file_name;
    while (fp < 0)
    {
        if ((*curr_ptr >= 'c' && *curr_ptr <= 'z') || (*curr_ptr >= 'C' && *curr_ptr <= 'Z'))
        {
            fp = FS_Open(SP0821_set_file_name, FS_READ_ONLY);
            if (fp >= 0)
            {
                break; /* Find the setting file. */
            }
            *curr_ptr = *curr_ptr + 1;
        }
        else
        {
            break ;
        }
    }
    if (fp < 0)    /* Error handle */
    {
        kal_prompt_trace (MOD_ENG,"!!! Warning, Can't find the initial setting file!!!");
        return 0;
    }
    FS_GetFileSize(fp, &file_size);
    if (file_size < 20)
    {
        kal_prompt_trace (MOD_ENG,"!!! Warning, Invalid setting file!!!");
        return 0;      /* Invalid setting file. */
    }
    #if 1
    	//data_buff = med_alloc_ext_mem(file_size);
	#ifdef __MRE_AM__
     data_buff = (kal_uint8*)applib_mem_ap_alloc_framebuffer(APPLIB_MEM_AP_ID_AM, file_size);
	#else
	data_buff = (kal_uint8*)applib_mem_ap_alloc_framebuffer(APPLIB_MEM_AP_ID_MMS_VIEWER, file_size);
	#endif
    if (data_buff == NULL)
    {
        kal_prompt_trace(MOD_ENG, "!!! Warning, Memory not enoughed...");
        return 0;        /* Memory not enough */
    }
	#endif
    FS_Read(fp, data_buff, file_size, &bytes_read);
    /* Start parse the setting witch read from t-flash. */
    curr_ptr = data_buff;
    while (curr_ptr < (data_buff + file_size))
    {
        while ((*curr_ptr == ' ') || (*curr_ptr == '\t'))/* Skip the Space & TAB */
            curr_ptr++;
        if (((*curr_ptr) == '/') && ((*(curr_ptr + 1)) == '*'))
        {
            while (!(((*curr_ptr) == '*') && ((*(curr_ptr + 1)) == '/')))
            {
                curr_ptr++;    /* Skip block comment code. */
            }
            while (!((*curr_ptr == 0x0D) && (*(curr_ptr+1) == 0x0A)))
            {
                curr_ptr++;
            }
            curr_ptr += 2;            /* Skip the enter line */
            continue ;
        }
        if (((*curr_ptr) == '/') || ((*curr_ptr) == '{') || ((*curr_ptr) == '}'))    /* Comment line, skip it. */
        {
            while (!((*curr_ptr == 0x0D) && (*(curr_ptr+1) == 0x0A)))
            {
                curr_ptr++;
            }
            curr_ptr += 2;            /* Skip the enter line */
            continue ;
        }
        /* This just content one enter line. */
        if (((*curr_ptr) == 0x0D) && ((*(curr_ptr + 1)) == 0x0A))
        {
            curr_ptr += 2;
            continue ;
        }
        kal_mem_cpy(func_ind, curr_ptr, 3);
        curr_ptr += 4;          /* Skip "REG(" or "DLY(" */
        if (strcmp((const char *)func_ind, "REG") == 0)    /* REG */
        {
            SP0821_Init_Reg[i].op_code = SP0821_OP_CODE_REG;
            SP0821_Init_Reg[i].init_reg = strtol((const char *)curr_ptr, NULL, 16);
            curr_ptr += 5;  /* Skip "0x0000);" */      
            SP0821_Init_Reg[i].init_val = strtol((const char *)curr_ptr, NULL, 16);
            curr_ptr += 6;  /* Skip "0x0000);" */  
        }
        else                  /* DLY */
        {
            /* Need add delay for this setting. */
            SP0821_Init_Reg[i].op_code = SP0821_OP_CODE_DLY;
            SP0821_Init_Reg[i].init_reg = 0xFF;
            SP0821_Init_Reg[i].init_val = strtol((const char *)curr_ptr, NULL, 10);  /* Get the delay ticks, the delay should less then 50 */
        }
        i++;
        /* Skip to next line directly. */
        while (!((*curr_ptr == 0x0D) && (*(curr_ptr+1) == 0x0A)))
        {
            curr_ptr++;
        }
        curr_ptr += 2;
    }
    /* (0xFFFF, 0xFFFF) means the end of initial setting. */
    SP0821_Init_Reg[i].op_code = SP0821_OP_CODE_END;
    SP0821_Init_Reg[i].init_reg = 0xFF;
    SP0821_Init_Reg[i].init_val = 0xFF;
    i++;

     kal_prompt_trace (MOD_ENG,"%d register read...", i - 1);
    //med_free_ext_mem((void **)&data_buff);
    FS_Close(fp);
    applib_mem_ap_free(data_buff);

     kal_prompt_trace (MOD_ENG,"Start apply initialize setting.");
    /* Start apply the initial setting to sensor. */
    for (j=0; j<i; j++)
    {
        if (SP0821_Init_Reg[j].op_code == SP0821_OP_CODE_END)  /* End of the setting. */
        {
            break ;
        }
        else if (SP0821_Init_Reg[j].op_code == SP0821_OP_CODE_DLY)
        {
            kal_sleep_task(SP0821_Init_Reg[j].init_val);    /* Delay */
        }
        else if (SP0821_Init_Reg[j].op_code == SP0821_OP_CODE_REG)
        {
            CamWriteCmosSensor(SP0821_Init_Reg[j].init_reg, SP0821_Init_Reg[j].init_val);
        }
        else
        {
            ASSERT(0);
        }
    }
     kal_prompt_trace (MOD_ENG,"%d register applied...", j);
    return 1;  
}
#endif







/*************************************************************************
* FUNCTION
*   SP0821_SERIALSetMirror
*
* DESCRIPTION
*   This function set the mirror to the CMOS sensor
*
* PARAMETERS
*   Mirror
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALSetMirror(kal_uint8 Mirror)
{
  kal_uint8 CntrB;
  
  switch (Mirror)
  {
  case IMAGE_SENSOR_MIRROR_NORMAL:
  	CamWriteCmosSensor(0x31, 0x00); 
    break;
  case IMAGE_SENSOR_MIRROR_H:
    CamWriteCmosSensor(0x31, 0x02); 
    break;
  case IMAGE_SENSOR_MIRROR_V:
    CamWriteCmosSensor(0x31, 0x04); 
    break;
  case IMAGE_SENSOR_MIRROR_HV:
    CamWriteCmosSensor(0x31, 0x06); 
    break;
  default:
    /* no need to do error handling */
    break;
  }
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSetClock
*
* DESCRIPTION
*   This function set sensor internal clock and output clock
*
* PARAMETERS
*   Clk: internal clock
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALSetClock(kal_uint32 InternalClock)
{
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALWriteShutter
*
* DESCRIPTION
*   This function apply shutter to sensor
*
* PARAMETERS
*   Shutter: integration time, unit: (linelength / internal clock) s
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALWriteShutter(kal_uint32 Shutter)
{
    // TODO: set integration time here
	//CamWriteCmosSensor(0x03, Shutter >> 8);
	//CamWriteCmosSensor(0x04, Shutter);    
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALReadShutter
*
* DESCRIPTION
*   This function get shutter from sensor
*
* PARAMETERS
*   None
*
* RETURNS
*   Shutter: integration time, unit: (linelength / internal clock) s
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint32 SP0821_SERIALReadShutter(void)
{
    // TODO: read integration time here
	//return (CamReadCmosSensor(0x03) << 8)|CamReadCmosSensor(0x04);
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALWriteGain
*
* DESCRIPTION
*   This function apply global gain to sensor
*
* PARAMETERS
*   Gain: base on 0x40
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALWriteGain(kal_uint32 Gain)
{
    // TODO: set global gain here
    
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALReadGain
*
* DESCRIPTION
*   This function get global gain from sensor
*
* PARAMETERS
*   None
*
* RETURNS
*   Gain: base on 0x40
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint32 SP0821_SERIALReadGain(void)
{
    // TODO: read global gain here
    
  //  return 0x40;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALAeEnable
*
* DESCRIPTION
*   disable/enable AE
*
* PARAMETERS
*   Enable
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALAeEnable(kal_bool Enable)
{
	if (SP0821_SERIALSensor.BypassAe)
	{
		Enable = KAL_FALSE;
	}
	
	// TODO: enable or disable AE here
	{
		kal_uint16 temp_ae_reg = CamReadCmosSensor(0x32);
		if (Enable)
		{
	    		CamWriteCmosSensor(0x32, (temp_ae_reg | 0x01));
		}
		else
		{
	    		CamWriteCmosSensor(0x32, (temp_ae_reg & (~0x01))); /* Turn OFF AEC/AGC*/
		}
	}
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALAwbEnable
*
* DESCRIPTION
*   disable/enable awb
*
* PARAMETERS
*   Enable
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALAwbEnable(kal_bool Enable)
{
	if (SP0821_SERIALSensor.BypassAwb)
	{
		Enable = KAL_FALSE;
	}
	
	// TODO: enable or disable AWB here
	{
		kal_uint16 temp_awb_reg = CamReadCmosSensor(0x32);
		if (Enable)
		{
	    		CamWriteCmosSensor(0x32, (temp_awb_reg | 0x02));
		}
		else
		{
	    		CamWriteCmosSensor(0x32, (temp_awb_reg & (~0x02))); /* Turn OFF AWB*/
		}
	}
}


/*************************************************************************
* FUNCTION
*   SP0821_SERIALSetBandingStep
*
* DESCRIPTION
*   This function is to calculate & set shutter step register .
*
*************************************************************************/
static void SP0821_SERIALSetBandingStep(CAL_CAMERA_BANDING_FREQ_ENUM BandingFreq)
{
    // TODO: set banding step here
    
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSetDummy
*
* DESCRIPTION
*   This function set the dummy pixels(Horizontal Blanking) & dummy lines(Vertical Blanking), it can be
*   used to adjust the frame rate or gain more time for back-end process.
*
* PARAMETERS
*   DummyPixel
*   DummyLine
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALSetDummy(kal_uint32 DummyPixel, kal_uint32 DummyLine)
{
#if 0
    kal_uint32 LineLength, FrameLength;

    if (SP0821_SERIALSensor.PvMode) /* preview size output mode */
    {
        LineLength = DummyPixel + SP0821_SERIAL_PV_PERIOD_PIXEL_NUMS;
        FrameLength = DummyLine + SP0821_SERIAL_PV_PERIOD_LINE_NUMS;
    }
    else
    {
        LineLength = DummyPixel + SP0821_SERIAL_FULL_PERIOD_PIXEL_NUMS;
        FrameLength = DummyLine + SP0821_SERIAL_FULL_PERIOD_LINE_NUMS;
    }

    // TODO: set linelength/framelength or dummy pixel/line and return right value here
    {
        
    }
#endif
    /* config banding step or base shutter */
  //  if (SP0821_SERIALSensor.PvMode) /* preview size output mode */
  //  {
   //     SP0821_SERIALSetBandingStep();
   // }
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSetMinFps
*
* DESCRIPTION
*   This function calculate & set min frame rate
*
* PARAMETERS
*   Fps: min frame rate, base on SP0821_SERIAL_FPS(x)
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALSetMinFps(kal_uint16 Fps)
{
    // TODO: set max exposure time or max AE index here
    
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSetMaxFps
*
* DESCRIPTION
*   This function calculate & set max frame rate
*
* PARAMETERS
*   Fps: max frame rate, base on SP0821_SERIAL_FPS(x)
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALSetMaxFps(kal_uint16 Fps)
{
}



/*************************************************************************
* FUNCTION
*   SP0821_SERIALSetNightMode
*
* DESCRIPTION
*   This function switch on/off night mode of SP0821_SERIAL.
*
*************************************************************************/
static void SP0821_SERIALSetVideoFps(kal_uint16 Fps)
{
    // TODO: fix, set max exposure time or max AE index here
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALNightMode
*
* DESCRIPTION
*   This function set night mode to sensor.
*
* PARAMETERS
*   Enable
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALNightMode(kal_bool videomode,kal_uint8 banding,kal_bool nightmode)
{
	if(RD_Tcard_OK == KAL_FALSE)
		{
	#if 1 //test,20171030
	if (KAL_FALSE ==nightmode) //daylight
	{	
		if(KAL_TRUE == videomode)	
			{
				if(banding == CAM_BANDING_50HZ)
				{
					//Video record daylight 24M 50hz fix 14-8FPS 
					CamWriteCmosSensor(0x03,0x00); 		 
					CamWriteCmosSensor(0x04,0x9c);
					CamWriteCmosSensor(0xe7,0x03);
					CamWriteCmosSensor(0xe7,0x00);
					CamWriteCmosSensor(0x32,0x07); 	
					CamWriteCmosSensor(0x05,0x00); 		 
					CamWriteCmosSensor(0x06,0x00); 		 
					CamWriteCmosSensor(0x09,0x00); 		 
					CamWriteCmosSensor(0x0a,0xec); 
								 				               
					CamWriteCmosSensor(0x9b,0x32);//base			 
					CamWriteCmosSensor(0x9c,0x00); 
							 							         
					CamWriteCmosSensor(0xa2,0xbc);//exp			 
					CamWriteCmosSensor(0xa3,0x02); 		 
					CamWriteCmosSensor(0xa4,0x32); 		 
					CamWriteCmosSensor(0xa5,0x00); 		 
					CamWriteCmosSensor(0xa8,0x32); 		 
					CamWriteCmosSensor(0xa9,0x00); 		 
					CamWriteCmosSensor(0xaa,0x01); 		 
					CamWriteCmosSensor(0xab,0x00);
	
		                   CamWriteCmosSensor(0xa6,SP0821_DAYLIGHT_MAXGAIN );
		                   CamWriteCmosSensor(0xac,SP0821_DAYLIGHT_MAXGAIN );
	
					dbg_print(" video 50Hz normal\r\n");
				}
				else if(banding == CAM_BANDING_60HZ)
				{
					//Video record daylight 24M 60hz fix 14-8FPS 
					CamWriteCmosSensor(0x03,0x00); 		 
					CamWriteCmosSensor(0x04,0x9c);
					CamWriteCmosSensor(0xe7,0x03);
					CamWriteCmosSensor(0xe7,0x00);
					CamWriteCmosSensor(0x32,0x07); 	
					CamWriteCmosSensor(0x05,0x00); 		 
					CamWriteCmosSensor(0x06,0x00); 		 
					CamWriteCmosSensor(0x09,0x00); 		 
					CamWriteCmosSensor(0x0a,0xec); 
								 				               
					CamWriteCmosSensor(0x9b,0x32);//base			 
					CamWriteCmosSensor(0x9c,0x00); 
							 							         
					CamWriteCmosSensor(0xa2,0xbc);//exp			 
					CamWriteCmosSensor(0xa3,0x02); 		 
					CamWriteCmosSensor(0xa4,0x32); 		 
					CamWriteCmosSensor(0xa5,0x00); 		 
					CamWriteCmosSensor(0xa8,0x32); 		 
					CamWriteCmosSensor(0xa9,0x00); 		 
					CamWriteCmosSensor(0xaa,0x01); 		 
					CamWriteCmosSensor(0xab,0x00);
	
		                   CamWriteCmosSensor(0xa6,SP0821_DAYLIGHT_MAXGAIN );
		                   CamWriteCmosSensor(0xac,SP0821_DAYLIGHT_MAXGAIN );
					dbg_print(" video 60Hz normal\r\n");
				}
			}
		else
			{
				if(banding == CAM_BANDING_50HZ)
				{
				//caprure preview daylight 24M 50hz 14.37-8FPS
					CamWriteCmosSensor(0x03,0x00); 		 
					CamWriteCmosSensor(0x04,0x9c);
					CamWriteCmosSensor(0xe7,0x03);
					CamWriteCmosSensor(0xe7,0x00);
					CamWriteCmosSensor(0x32,0x07); 	
					CamWriteCmosSensor(0x05,0x00); 		 
					CamWriteCmosSensor(0x06,0x00); 		 
					CamWriteCmosSensor(0x09,0x00); 		 
					CamWriteCmosSensor(0x0a,0xec); 
								 				               
					CamWriteCmosSensor(0x9b,0x32);//base			 
					CamWriteCmosSensor(0x9c,0x00); 
							 							         
					CamWriteCmosSensor(0xa2,0xbc);//exp			 
					CamWriteCmosSensor(0xa3,0x02); 		 
					CamWriteCmosSensor(0xa4,0x32); 		 
					CamWriteCmosSensor(0xa5,0x00); 		 
					CamWriteCmosSensor(0xa8,0x32); 		 
					CamWriteCmosSensor(0xa9,0x00); 		 
					CamWriteCmosSensor(0xaa,0x01); 		 
					CamWriteCmosSensor(0xab,0x00);
	
		                   CamWriteCmosSensor(0xa6,SP0821_DAYLIGHT_MAXGAIN );
		                   CamWriteCmosSensor(0xac,SP0821_DAYLIGHT_MAXGAIN );
					dbg_print(" priview 50Hz normal\r\n");
				 
				}
				else if(banding == CAM_BANDING_60HZ)
				{
					//caprure preview daylight 24M 60hz 14.37-8FPS
					CamWriteCmosSensor(0x03,0x00); 		 
					CamWriteCmosSensor(0x04,0x9c);
					CamWriteCmosSensor(0xe7,0x03);
					CamWriteCmosSensor(0xe7,0x00);
					CamWriteCmosSensor(0x32,0x07); 	
					CamWriteCmosSensor(0x05,0x00); 		 
					CamWriteCmosSensor(0x06,0x00); 		 
					CamWriteCmosSensor(0x09,0x00); 		 
					CamWriteCmosSensor(0x0a,0xec); 
								 				               
					CamWriteCmosSensor(0x9b,0x32);//base			 
					CamWriteCmosSensor(0x9c,0x00); 
							 							         
					CamWriteCmosSensor(0xa2,0xbc);//exp			 
					CamWriteCmosSensor(0xa3,0x02); 		 
					CamWriteCmosSensor(0xa4,0x32); 		 
					CamWriteCmosSensor(0xa5,0x00); 		 
					CamWriteCmosSensor(0xa8,0x32); 		 
					CamWriteCmosSensor(0xa9,0x00); 		 
					CamWriteCmosSensor(0xaa,0x01); 		 
					CamWriteCmosSensor(0xab,0x00);
	
		                   CamWriteCmosSensor(0xa6,SP0821_DAYLIGHT_MAXGAIN );
		                   CamWriteCmosSensor(0xac,SP0821_DAYLIGHT_MAXGAIN );
					dbg_print(" priview 60Hz normal\r\n");
				
				 
				}
			}	
		}
	else //night mode
	{
			if(KAL_TRUE == videomode)		
			{
				if(banding == CAM_BANDING_50HZ)
				{
					//Video record night 24M 50hz  fix 14-8FPS 
					CamWriteCmosSensor(0x03,0x00); 		 
					CamWriteCmosSensor(0x04,0x9c);
					CamWriteCmosSensor(0xe7,0x03);
					CamWriteCmosSensor(0xe7,0x00);
					CamWriteCmosSensor(0x32,0x07); 	
					CamWriteCmosSensor(0x05,0x00); 		 
					CamWriteCmosSensor(0x06,0x00); 		 
					CamWriteCmosSensor(0x09,0x00); 		 
					CamWriteCmosSensor(0x0a,0xec); 
								 				               
					CamWriteCmosSensor(0x9b,0x32);//base			 
					CamWriteCmosSensor(0x9c,0x00); 
							 							         
					CamWriteCmosSensor(0xa2,0xbc);//exp			 
					CamWriteCmosSensor(0xa3,0x02); 		 
					CamWriteCmosSensor(0xa4,0x32); 		 
					CamWriteCmosSensor(0xa5,0x00); 		 
					CamWriteCmosSensor(0xa8,0x32); 		 
					CamWriteCmosSensor(0xa9,0x00); 		 
					CamWriteCmosSensor(0xaa,0x01); 		 
					CamWriteCmosSensor(0xab,0x00);
	
		                   CamWriteCmosSensor(0xa6,SP0821_DAYLIGHT_MAXGAIN );
		                   CamWriteCmosSensor(0xac,SP0821_DAYLIGHT_MAXGAIN );
					dbg_print(" video 50Hz night\r\n"); 			
				}
				else if(banding == CAM_BANDING_60HZ)
				{
					//Video record night 24M 60hz fix 9FPS
					CamWriteCmosSensor(0x03,0x00); 		 
					CamWriteCmosSensor(0x04,0x9c);
					CamWriteCmosSensor(0xe7,0x03);
					CamWriteCmosSensor(0xe7,0x00);
					CamWriteCmosSensor(0x32,0x07); 	
					CamWriteCmosSensor(0x05,0x00); 		 
					CamWriteCmosSensor(0x06,0x00); 		 
					CamWriteCmosSensor(0x09,0x00); 		 
					CamWriteCmosSensor(0x0a,0xec); 
								 				               
					CamWriteCmosSensor(0x9b,0x32);//base			 
					CamWriteCmosSensor(0x9c,0x00); 
							 							         
					CamWriteCmosSensor(0xa2,0xbc);//exp			 
					CamWriteCmosSensor(0xa3,0x02); 		 
					CamWriteCmosSensor(0xa4,0x32); 		 
					CamWriteCmosSensor(0xa5,0x00); 		 
					CamWriteCmosSensor(0xa8,0x32); 		 
					CamWriteCmosSensor(0xa9,0x00); 		 
					CamWriteCmosSensor(0xaa,0x01); 		 
					CamWriteCmosSensor(0xab,0x00);
	
		                   CamWriteCmosSensor(0xa6,SP0821_DAYLIGHT_MAXGAIN );
		                   CamWriteCmosSensor(0xac,SP0821_DAYLIGHT_MAXGAIN );
					dbg_print(" video 60Hz night\r\n"); 
				}
			}
		   else
			{
				dbg_print(" banding=%x\r\n",banding);
				if(banding == CAM_BANDING_50HZ)
				{
					//caprure preview night 24M 50hz 14.07-8FPS	
					CamWriteCmosSensor(0x03,0x00); 		 
					CamWriteCmosSensor(0x04,0x9c);
					CamWriteCmosSensor(0xe7,0x03);
					CamWriteCmosSensor(0xe7,0x00);
					CamWriteCmosSensor(0x32,0x07); 	
					CamWriteCmosSensor(0x05,0x00); 		 
					CamWriteCmosSensor(0x06,0x00); 		 
					CamWriteCmosSensor(0x09,0x00); 		 
					CamWriteCmosSensor(0x0a,0xec); 
								 				               
					CamWriteCmosSensor(0x9b,0x32);//base			 
					CamWriteCmosSensor(0x9c,0x00); 
							 							         
					CamWriteCmosSensor(0xa2,0xbc);//exp			 
					CamWriteCmosSensor(0xa3,0x02); 		 
					CamWriteCmosSensor(0xa4,0x32); 		 
					CamWriteCmosSensor(0xa5,0x00); 		 
					CamWriteCmosSensor(0xa8,0x32); 		 
					CamWriteCmosSensor(0xa9,0x00); 		 
					CamWriteCmosSensor(0xaa,0x01); 		 
					CamWriteCmosSensor(0xab,0x00);
	
		                   CamWriteCmosSensor(0xa6,SP0821_DAYLIGHT_MAXGAIN );
		                   CamWriteCmosSensor(0xac,SP0821_DAYLIGHT_MAXGAIN );
					dbg_print(" priview 50Hz night\r\n");	
				}
				else if(banding == CAM_BANDING_60HZ)
				{
					//caprure preview night 24M 60hz 14.01-8FPS	
					CamWriteCmosSensor(0x03,0x00); 		 
					CamWriteCmosSensor(0x04,0x9c);
					CamWriteCmosSensor(0xe7,0x03);
					CamWriteCmosSensor(0xe7,0x00);
					CamWriteCmosSensor(0x32,0x07); 	
					CamWriteCmosSensor(0x05,0x00); 		 
					CamWriteCmosSensor(0x06,0x00); 		 
					CamWriteCmosSensor(0x09,0x00); 		 
					CamWriteCmosSensor(0x0a,0xec); 
								 				               
					CamWriteCmosSensor(0x9b,0x32);//base			 
					CamWriteCmosSensor(0x9c,0x00); 
							 							         
					CamWriteCmosSensor(0xa2,0xbc);//exp			 
					CamWriteCmosSensor(0xa3,0x02); 		 
					CamWriteCmosSensor(0xa4,0x32); 		 
					CamWriteCmosSensor(0xa5,0x00); 		 
					CamWriteCmosSensor(0xa8,0x32); 		 
					CamWriteCmosSensor(0xa9,0x00); 		 
					CamWriteCmosSensor(0xaa,0x01); 		 
					CamWriteCmosSensor(0xab,0x00);
	
		                   CamWriteCmosSensor(0xa6,SP0821_DAYLIGHT_MAXGAIN );
		                   CamWriteCmosSensor(0xac,SP0821_DAYLIGHT_MAXGAIN );
					dbg_print(" priview 60Hz night\r\n");	
				}
			}
	}
	
#endif
	}
	
}


/*************************************************************************
* FUNCTION
*   SP0821_SERIALEv
*
* DESCRIPTION
*   Exposure setting.
*
* PARAMETERS
*   In, Out
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0821_SERIALEv(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
	#if 1		//return; //test,20171030
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Exposure = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;

    Exposure->IsSupport = KAL_TRUE;
    Exposure->ItemCount = 10;
    Exposure->SupportItem[0] = CAM_EV_NEG_4_3;
    Exposure->SupportItem[1] = CAM_EV_NEG_3_3;
    Exposure->SupportItem[2] = CAM_EV_NEG_2_3;
    Exposure->SupportItem[3] = CAM_EV_NEG_1_3;
    Exposure->SupportItem[4] = CAM_EV_ZERO;
    Exposure->SupportItem[5] = CAM_EV_POS_1_3;
    Exposure->SupportItem[6] = CAM_EV_POS_2_3;
    Exposure->SupportItem[7] = CAM_EV_POS_3_3;
    Exposure->SupportItem[8] = CAM_EV_POS_4_3;
    Exposure->SupportItem[9] = CAM_EV_NIGHT_SHOT;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {  
    switch (In->FeatureSetValue)
    {
    case CAM_EV_NEG_4_3:
      		        CamWriteCmosSensor(0x61,0xc0);    
      		  
      break;
    case CAM_EV_NEG_3_3:
      		        CamWriteCmosSensor(0x61,0xd0);   
      break;
    case CAM_EV_NEG_2_3:
			CamWriteCmosSensor(0x61,0xe0);     
      break;
    case CAM_EV_NEG_1_3:
			CamWriteCmosSensor(0x61,0xf0);    
      break;
    case CAM_EV_ZERO:
                       CamWriteCmosSensor(0x61,0x00); 
      break;
    case CAM_EV_POS_1_3:
			CamWriteCmosSensor(0x61,0x10);   
      break;
    case CAM_EV_POS_2_3:
			CamWriteCmosSensor(0x61,0x20);     
      break;
    case CAM_EV_POS_3_3:
      		       CamWriteCmosSensor(0x61,0x30);    
      break;
    case CAM_EV_POS_4_3:
      		       CamWriteCmosSensor(0x61,0x40); 
      break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
  }
  #endif
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALContrast
*
* DESCRIPTION
*   Contrast setting.
*
* PARAMETERS
*   In, Out
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0821_SERIALContrast(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
	#if 1	//return; //test,20171030
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Contrast = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;

    Contrast->IsSupport = KAL_TRUE;
    Contrast->ItemCount = 3;
    Contrast->SupportItem[0] = CAM_CONTRAST_HIGH;
    Contrast->SupportItem[1] = CAM_CONTRAST_MEDIUM;
    Contrast->SupportItem[2] = CAM_CONTRAST_LOW;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    switch (In->FeatureSetValue)
    {
    case CAM_CONTRAST_HIGH:
		CamWriteCmosSensor(0x58, 0x90);
		CamWriteCmosSensor(0x59, 0x90);
      break;
    case CAM_CONTRAST_MEDIUM:
		CamWriteCmosSensor(0x58, 0x80);
		CamWriteCmosSensor(0x59, 0x90);
      break;
    case CAM_CONTRAST_LOW:
		CamWriteCmosSensor(0x58, 0x70);
		CamWriteCmosSensor(0x59, 0x90);
      break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
  }
  #endif
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSaturation
*
* DESCRIPTION
*   Saturation setting.
*
* PARAMETERS
*   In, Out
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0821_SERIALSaturation(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
	#if 1	//return; //test,20171030
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Saturation = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    // TODO: add supported saturation enum here
    Saturation->IsSupport = KAL_FALSE;
    //Saturation->ItemCount = 3;
    //Saturation->SupportItem[0] = CAM_SATURATION_HIGH;
    //Saturation->SupportItem[1] = CAM_SATURATION_MEDIUM;
    //Saturation->SupportItem[2] = CAM_SATURATION_LOW;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    // TODO: adjust saturation here
    //switch (In->FeatureSetValue)
    //{
    //case CAM_SATURATION_HIGH:
    //  break;
    //case CAM_SATURATION_MEDIUM:
    //  break;
    //case CAM_SATURATION_LOW:
    //  break;
    //default:
    //  return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    //}
  }
  #endif
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSharpness
*
* DESCRIPTION
*   Sharpness setting.
*
* PARAMETERS
*   In, Out
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0821_SERIALSharpness(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
	#if 1	//return; //test,20171030
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Sharpness = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    // TODO: add supported sharpness enum here
    Sharpness->IsSupport = KAL_FALSE;
    //Sharpness->ItemCount = 3;
    //Sharpness->SupportItem[0] = CAM_SHARPNESS_HIGH;
    //Sharpness->SupportItem[1] = CAM_SHARPNESS_MEDIUM;
    //Sharpness->SupportItem[2] = CAM_SHARPNESS_LOW;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    // TODO: adjust sharpness here
    //switch (In->FeatureSetValue)
    //{
    //case CAM_SHARPNESS_HIGH:
    //  break;
    //case CAM_SHARPNESS_MEDIUM:
    //  break;
    //case CAM_SHARPNESS_LOW:
    //  break;
    //default:
    //  return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    //}
  }
  	#endif
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALWb
*
* DESCRIPTION
*   Wb setting.
*
* PARAMETERS
*   In, Out
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0821_SERIALWb(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
	#if 1	//return; //test,20171030
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Wb = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;

    Wb->IsSupport = KAL_TRUE;
    Wb->ItemCount = 6;
    Wb->SupportItem[0] = CAM_WB_AUTO;
    Wb->SupportItem[1] = CAM_WB_CLOUD;
    Wb->SupportItem[2] = CAM_WB_DAYLIGHT;
    Wb->SupportItem[3] = CAM_WB_INCANDESCENCE;
    Wb->SupportItem[4] = CAM_WB_FLUORESCENT;
    Wb->SupportItem[5] = CAM_WB_TUNGSTEN;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    switch (In->FeatureSetValue)
    {
    case CAM_WB_AUTO:
		CamWriteCmosSensor(0xc5, 0xdf);
		CamWriteCmosSensor(0xc6, 0xb1);
		CamWriteCmosSensor(0xe7, 0x03);
		CamWriteCmosSensor(0xe7, 0x00);
		CamWriteCmosSensor(0x32, 0x07);
		SP0821_SERIALAwbEnable(KAL_TRUE);
      break;
    case CAM_WB_CLOUD:
		SP0821_SERIALAwbEnable(KAL_FALSE);
		CamWriteCmosSensor(0x32, 0x05);
		CamWriteCmosSensor(0xc5, 0xe5);	
		CamWriteCmosSensor(0xc6, 0x80);	
      break;
    case CAM_WB_DAYLIGHT:
		SP0821_SERIALAwbEnable(KAL_FALSE);
		CamWriteCmosSensor(0x32, 0x05);
		CamWriteCmosSensor(0xc5, 0xc5);	
		CamWriteCmosSensor(0xc6, 0x8a);	
      break;
    case CAM_WB_INCANDESCENCE:
		SP0821_SERIALAwbEnable(KAL_FALSE);
		CamWriteCmosSensor(0x32, 0x05);
		CamWriteCmosSensor(0xc5, 0xa8);	
		CamWriteCmosSensor(0xc6, 0xae);	
      break;
    case CAM_WB_FLUORESCENT:
		SP0821_SERIALAwbEnable(KAL_FALSE);
		CamWriteCmosSensor(0x32, 0x05);
		CamWriteCmosSensor(0xc5, 0x9c);
		CamWriteCmosSensor(0xc6, 0xaf);	
      break;
    case CAM_WB_TUNGSTEN:
		SP0821_SERIALAwbEnable(KAL_FALSE);
		CamWriteCmosSensor(0x32, 0x05);
		CamWriteCmosSensor(0xc5, 0xa8);
		CamWriteCmosSensor(0xc6, 0xb7);	
      break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
  }
  #endif
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALEffect
*
* DESCRIPTION
*   Effect setting.
*
* PARAMETERS
*   In, Out
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0821_SERIALEffect(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
	#if 1	//return; //test,20171030
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Effect = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;

    Effect->IsSupport = KAL_TRUE;
    Effect->ItemCount = 6;
    Effect->SupportItem[0] = CAM_EFFECT_ENC_NORMAL;
    Effect->SupportItem[1] = CAM_EFFECT_ENC_GRAYSCALE;
    Effect->SupportItem[2] = CAM_EFFECT_ENC_SEPIA;
    Effect->SupportItem[3] = CAM_EFFECT_ENC_SEPIAGREEN;
    Effect->SupportItem[4] = CAM_EFFECT_ENC_SEPIABLUE;
    Effect->SupportItem[5] = CAM_EFFECT_ENC_COLORINV;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    switch (In->FeatureSetValue)
    {
    case CAM_EFFECT_ENC_NORMAL:
			CamWriteCmosSensor(0x62, 0x00);
			CamWriteCmosSensor(0x36, 0x80);
			CamWriteCmosSensor(0x37, 0x80);
      break;
    case CAM_EFFECT_ENC_GRAYSCALE:
			CamWriteCmosSensor(0x62, 0x04);
			CamWriteCmosSensor(0x36, 0x80);
			CamWriteCmosSensor(0x37, 0x80);
      break;
    case CAM_EFFECT_ENC_SEPIA:
			CamWriteCmosSensor(0x62, 0x08);
			CamWriteCmosSensor(0x36, 0xb0);
			CamWriteCmosSensor(0x37, 0x00);
      break;
    case CAM_EFFECT_ENC_SEPIAGREEN:
			CamWriteCmosSensor(0x62, 0x08);
			CamWriteCmosSensor(0x36, 0x50);
			CamWriteCmosSensor(0x37, 0x50);     
      break;
    case CAM_EFFECT_ENC_SEPIABLUE:
			CamWriteCmosSensor(0x62, 0x08);
			CamWriteCmosSensor(0x36, 0x20);
			CamWriteCmosSensor(0x37, 0xf0);
      break;
    case CAM_EFFECT_ENC_COLORINV:
			CamWriteCmosSensor(0x62, 0x01);
			CamWriteCmosSensor(0x36, 0x80);
			CamWriteCmosSensor(0x37, 0x80);
      break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
  }
  #endif
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALStillCaptureSize
*
* DESCRIPTION
*   This function get capture size
*
* PARAMETERS
*   In, Out
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
MM_ERROR_CODE_ENUM SP0821_SERIALStillCaptureSize(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
  const P_CAL_FEATURE_TYPE_ENUM_STRUCT CapSize = &Out->FeatureInfo.FeatureEnum;
  
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_SUPPORT;
    CapSize->IsSupport = KAL_TRUE;
    CapSize->ItemCount = 3;
    CapSize->SupportItem[0] = CAM_IMAGE_SIZE_WALLPAPER;
	CapSize->SupportItem[1] = CAM_IMAGE_SIZE_QVGA;
    CapSize->SupportItem[2] = CAM_IMAGE_SIZE_VGA;
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALBanding
*
* DESCRIPTION
*   This function get banding setting
*
* PARAMETERS
*   In, Out
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0821_SERIALBanding(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{

  const P_CAL_FEATURE_TYPE_ENUM_STRUCT Banding = &Out->FeatureInfo.FeatureEnum;
  
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    Banding->IsSupport = KAL_TRUE;
    Banding->ItemCount = 2;
    Banding->SupportItem[0] = CAM_BANDING_50HZ;
    Banding->SupportItem[1] = CAM_BANDING_60HZ;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
        SP0821_SERIALSensor.BandingFreq = (CAM_BANDING_50HZ == In->FeatureSetValue ? SP0821_SERIAL_50HZ : SP0821_SERIAL_60HZ);
        // TODO: set manual banding here
        {
            if (CAM_BANDING_50HZ == In->FeatureSetValue)
            {
			// based on 24M MCLK 
		
			SP0821_SERIAL_CAM_BANDING_50HZ = KAL_TRUE;
            }
            else
            {			
			SP0821_SERIAL_CAM_BANDING_50HZ = KAL_FALSE;
            }
        }
    }
    return MM_ERROR_NONE;
	
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSceneMode
*
* DESCRIPTION
*   This function get/set scene mode of sensor.
*
* PARAMETERS
*   IsCam: camera scene mode or not
*   In, Out
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0821_SERIALSceneMode(kal_bool IsCam, P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
	#if 1	//return; //test,20171030
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT SceneMode = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_SUPPORT;
    SceneMode->IsSupport = KAL_TRUE;
    SceneMode->ItemCount = 2;
    if (IsCam)
    {
      SceneMode->SupportItem[0] = CAM_AUTO_DSC;
      SceneMode->SupportItem[1] = CAM_NIGHTSCENE;
    }
    else
    {
      SceneMode->SupportItem[0] = CAM_VIDEO_AUTO;
      SceneMode->SupportItem[1] = CAM_VIDEO_NIGHT;
    }
  }
  #endif
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALInitialSetting
*
* DESCRIPTION
*   This function initialize the registers of CMOS sensor
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALInitialSetting(void)
{ 

CamWriteCmosSensor(0x31,0x02);


CamWriteCmosSensor(0x19,0x04);
CamWriteCmosSensor(0x2c,0x0f);
CamWriteCmosSensor(0x2e,0x3c);
CamWriteCmosSensor(0x30,0x01);

//0x10, 0x22,
CamWriteCmosSensor(0x28,0x2e);//0x22,mjb1023
CamWriteCmosSensor(0x29,0x1f);
CamWriteCmosSensor(0x0a,0x30);
CamWriteCmosSensor(0x0f,0x30);
CamWriteCmosSensor(0x14,0xb0);
CamWriteCmosSensor(0x38,0x50);
CamWriteCmosSensor(0x39,0x52);
CamWriteCmosSensor(0x3a,0x60);
CamWriteCmosSensor(0x3b,0x10);
CamWriteCmosSensor(0x3c,0xe0);
CamWriteCmosSensor(0x85,0x01);
CamWriteCmosSensor(0xe0,0x02);
CamWriteCmosSensor(0xe5,0x60);
CamWriteCmosSensor(0xf5,0x02);
CamWriteCmosSensor(0xf1,0x03);//sig num
CamWriteCmosSensor(0xf3,0x40);//scnt_dds  //mjb taiyangheizi
CamWriteCmosSensor(0x41,0x00);

CamWriteCmosSensor(0x03,0x00);//0x01
CamWriteCmosSensor(0x04,0x9c);//0xc2
CamWriteCmosSensor(0x05,0x00);//0x00
CamWriteCmosSensor(0x06,0x00);//0x00
CamWriteCmosSensor(0x07,0x00);
CamWriteCmosSensor(0x08,0x00);
CamWriteCmosSensor(0x09,0x00);//0x02;00
CamWriteCmosSensor(0x0a,0x34);//0xf4;9c
CamWriteCmosSensor(0x24,0x80);
CamWriteCmosSensor(0x0D,0x01);//1
CamWriteCmosSensor(0xc8,0x10);//y_bot_th
CamWriteCmosSensor(0x32,0x00);//awb 
CamWriteCmosSensor(0xc5,0xdf);//r 
CamWriteCmosSensor(0xc6,0xb1);//b
CamWriteCmosSensor(0xe7,0x03);//
CamWriteCmosSensor(0xe7,0x00);//
CamWriteCmosSensor(0x29,0x1e);//[0] 0ffset shift????  ;black level en


//caprure preview daylight 24M 50hz 14.07-8FPS
CamWriteCmosSensor(0x03,0x00);	 
CamWriteCmosSensor(0x04,0xb7);// 
CamWriteCmosSensor(0xe7,0x03);//
CamWriteCmosSensor(0xe7,0x00);//
CamWriteCmosSensor(0x32,0x07);//			
CamWriteCmosSensor(0x9b,0x32);//4b ;base			 
CamWriteCmosSensor(0x9c,0x00);//		 
CamWriteCmosSensor(0xa2,0xbc);//1a;b0 ;exp			 
CamWriteCmosSensor(0xa3,0x02);//04;04 ; 		 
CamWriteCmosSensor(0xa4,0x32);//4b ; 		 
CamWriteCmosSensor(0xa5,0x00);//		 
CamWriteCmosSensor(0xa8,0x32);//4b ; 		 
CamWriteCmosSensor(0xa9,0x00);//		 
CamWriteCmosSensor(0xaa,0x01);// 		 
CamWriteCmosSensor(0xab,0x00);//

CamWriteCmosSensor(0x4c,0x80);//gr pregain
CamWriteCmosSensor(0x4d,0x80);//gb

CamWriteCmosSensor(0xa6,0xc0);//max indoor gain
CamWriteCmosSensor(0xa7,0x10);//
CamWriteCmosSensor(0xac,0xc0);//max rpc outdoor
CamWriteCmosSensor(0xad,0x10);//
CamWriteCmosSensor(0x8a,0x1f);//
CamWriteCmosSensor(0x8b,0x18);//
CamWriteCmosSensor(0x8c,0x15);//
CamWriteCmosSensor(0x8d,0x13);//
CamWriteCmosSensor(0x8e,0x13);//
CamWriteCmosSensor(0x8f,0x12);//
CamWriteCmosSensor(0x90,0x12);//
CamWriteCmosSensor(0x91,0x11);//
CamWriteCmosSensor(0x92,0x11);//
CamWriteCmosSensor(0x93,0x11);//
CamWriteCmosSensor(0x94,0x10);//
CamWriteCmosSensor(0x95,0x10);//
CamWriteCmosSensor(0x96,0x10);//

//sat(by zhaifei)
CamWriteCmosSensor(0x17,0x7a);//
CamWriteCmosSensor(0x18,0x80);//
CamWriteCmosSensor(0x4e,0x70);//;78 ;vsat
CamWriteCmosSensor(0x4f,0x70);//;78 ;U
CamWriteCmosSensor(0x58,0x80);// ;ku heq 90;
CamWriteCmosSensor(0x59,0xa0);//90 ;kl  87;
CamWriteCmosSensor(0x5a,0x80);//;hep mean

//lum(by chengxinqiang)
CamWriteCmosSensor(0x86,0x08);//  auto lum lowlight
CamWriteCmosSensor(0x87,0x0f);//
CamWriteCmosSensor(0x88,0x30);//
CamWriteCmosSensor(0x89,0x45);//
CamWriteCmosSensor(0x98,0x88);//94target
CamWriteCmosSensor(0x9e,0x84);//90
CamWriteCmosSensor(0x9f,0x7c);//88
CamWriteCmosSensor(0x97,0x78);//84
CamWriteCmosSensor(0x9a,0x84);//90
CamWriteCmosSensor(0xa0,0x80);//8c
CamWriteCmosSensor(0xa1,0x78);//84
CamWriteCmosSensor(0x99,0x88);//80 
CamWriteCmosSensor(0x9d,0x0A);//
CamWriteCmosSensor(0x34,0x0f);//

//AWB;     
CamWriteCmosSensor(0xB1,0x04);//skin Y_BOT  
CamWriteCmosSensor(0xb3,0x00);//              
CamWriteCmosSensor(0x47,0x40);//skin num th2       
CamWriteCmosSensor(0xb8,0x04);//skin area                      
CamWriteCmosSensor(0xb9,0x28);//skin num th              
CamWriteCmosSensor(0x3f,0x18);//wt num th          
CamWriteCmosSensor(0xbf,0x33);//ff;rg_limit_log/bg_limit_log   
CamWriteCmosSensor(0xc1,0xff);//e0;rgain_top    
CamWriteCmosSensor(0xc2,0x40);//rgain_bot    
CamWriteCmosSensor(0xc3,0xff);//e0;bgain_top    
CamWriteCmosSensor(0xc4,0x40);//bgain_bot    
CamWriteCmosSensor(0xc5,0xdf);//77;buf_rgain    
CamWriteCmosSensor(0xc6,0xb1);//cd;buf_bgain    
CamWriteCmosSensor(0xc7,0xef);//y_top_th     
CamWriteCmosSensor(0xc8,0x10);//y_bot_th     
CamWriteCmosSensor(0x50,0x20);//18;09;0e;rg_dif_th2           
CamWriteCmosSensor(0x51,0x20);//12;09;0e;bg_dif_th2           
CamWriteCmosSensor(0x52,0x2f);//1f;0a;1f;rgb_limit2           
CamWriteCmosSensor(0x53,0x90);//ee;9e;a8;rg_base2 e6,//            
CamWriteCmosSensor(0x54,0xff);//b5;b4;bf;bg_base2 e7,//            
CamWriteCmosSensor(0x5c,0x1e);//09;0e;rg_dif_th1   
CamWriteCmosSensor(0x5d,0x21);//09;0e;bg_dif_th1   
CamWriteCmosSensor(0x5e,0x1a);//0a;1f;rgb_limit1   
CamWriteCmosSensor(0x5f,0xd8);//c3;c5;b0;rg_base1     
CamWriteCmosSensor(0x60,0xaa);//8d;8c;8e;bg_base1     
CamWriteCmosSensor(0xcb,0x12);//09;0e;rg_dif_th3   
CamWriteCmosSensor(0xcc,0x12);//09;0e;bg_dif_th3                          
CamWriteCmosSensor(0xcd,0x1f);//0a;1f;rgb_limit3   
CamWriteCmosSensor(0xce,0x90);//79;79;79;75;rg_base3     
CamWriteCmosSensor(0xcf,0xfa);//d5;d0;d5;b4;cc;bg_base3             

//ccm      75  gd                                      80 75 
CamWriteCmosSensor(0x79,0x57);//5C;62;63;58;40;40;40;40;40;80;// 08/22   58;58;5C;
CamWriteCmosSensor(0x7a,0xe0);//D7;DE;E9;E7;0 ;0 ;0 ;0 ;0 ;0 ;           E7;E7;D7;
CamWriteCmosSensor(0x7b,0x9);//D ;0 ;F4;1 ;0 ;0 ;0 ;0 ;0 ;0 ;           0 ;1 ;D ;
CamWriteCmosSensor(0x7c,0x2 );//5 ;5 ;F ;C ;F2;F2;Ec;EF;F6;EC;           C ;C ;5 ;
CamWriteCmosSensor(0x7d,0x40);//36;36;3C;38;50;58;5F;5F;56;AD;           38;38;36;
CamWriteCmosSensor(0x7e,0xfe );//5 ;5 ;F5;FC;FE;F6;F5;F2;F4;E7;           FB;FC;5 ;
CamWriteCmosSensor(0x7f,0xb );//9 ;A ;D ;C ;F5;F7;F6;F6;FD;FA;           C ;C ;9 ;
CamWriteCmosSensor(0x80,0xdf);//D7;D6;D9;E1;F1;F1;E8;E8;E4;C8;           E0;E1;D7;
CamWriteCmosSensor(0x81,0x56);//


//gamma; 
CamWriteCmosSensor(0x63,0x0 );//0822
CamWriteCmosSensor(0x64,0xA );
CamWriteCmosSensor(0x65,0x13);
CamWriteCmosSensor(0x66,0x1C);
CamWriteCmosSensor(0x67,0x25);
CamWriteCmosSensor(0x68,0x37);
CamWriteCmosSensor(0x69,0x46);
CamWriteCmosSensor(0x6a,0x52);
CamWriteCmosSensor(0x6b,0x5E);
CamWriteCmosSensor(0x6c,0x75);
CamWriteCmosSensor(0x6d,0x88);
CamWriteCmosSensor(0x6e,0x9A);
CamWriteCmosSensor(0x6f,0xA9);
CamWriteCmosSensor(0x70,0xB5);
CamWriteCmosSensor(0x71,0xC0);
CamWriteCmosSensor(0x72,0xCA);
CamWriteCmosSensor(0x73,0xD4);
CamWriteCmosSensor(0x74,0xDD);
CamWriteCmosSensor(0x75,0xE6);
CamWriteCmosSensor(0x76,0xEc);
CamWriteCmosSensor(0x77,0xF2);
CamWriteCmosSensor(0x78,0xF6);

//dns,sharpness(by zhaifei)
CamWriteCmosSensor(0x1b,0x0f);//02;01;02;02;03 ;05;dns_flat_thr1	dns       //822
CamWriteCmosSensor(0x1c,0x1a);//06;02;03;04;05 ;08;dns_flat_thr2           
CamWriteCmosSensor(0x1d,0x20);//0f;0a;04;05;0c;05 ;0a;dns_flat_thr3           
CamWriteCmosSensor(0x1e,0x2f);//1a;10;07;08;0a;0f;05 ;ff;dns_flat_thr4        
CamWriteCmosSensor(0x1f,0x0f);//06;04;04 ;05;sharp_flat_thr1 sharp      
CamWriteCmosSensor(0x20,0x1a);//0A;06;07 ;0a;sharp_flat_thr2            
CamWriteCmosSensor(0x21,0x20);//0D;08;12; 0a ;sharp_flat_thr3           
CamWriteCmosSensor(0x22,0x2f);//12;10;1a; 12 ;0a;sharp_flat_thr4        
CamWriteCmosSensor(0x56,0x37);//03;ff; raw_sharp_pos raw_sharp_neg
CamWriteCmosSensor(0x1a,0x16);//
CamWriteCmosSensor(0x34,0x1f);//
CamWriteCmosSensor(0x82,0x10);//
CamWriteCmosSensor(0x83,0x00);//
CamWriteCmosSensor(0x84,0xff);//
CamWriteCmosSensor(0xd7,0x70);//
CamWriteCmosSensor(0xd8,0x1f);//
CamWriteCmosSensor(0xd9,0x30);//
		dbg_print("SP0821_SERIALInitialSetting\r\n");

}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALPvSetting
*
* DESCRIPTION
*   This function apply the preview mode setting, normal the preview size is 1/4 of full size.
*   Ex. 2M (1600 x 1200)
*   Preview: 800 x 600 (use sub-sample or binning to acheive it)
*   Full Size: 1600 x 1200 (output every effective pixels.)
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALPvSetting(void)
{
    // TODO: add preview setting here
    
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALCapSetting
*
* DESCRIPTION
*   This function config capture settting to sensor
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALCapSetting(void)
{
	SP0821_SERIALSensor.Pclk = 24000000;		/* It is the PCLK for sensor internal parallel interface */	
	SP0821_SERIALSensor.PvMode = KAL_FALSE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALGetSensorInfo
*
* DESCRIPTION
*   This function set sensor infomation
*
* PARAMETERS
*   Info
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALGetSensorInfo(P_IMAGE_SENSOR_GET_SENSOR_INFO_STRUCT Info)
{
	Info->SensorId = SP0821_SERIAL_SENSOR_ID;
	Info->SensorIf = IMAGE_SENSOR_IF_SERIAL;

	Info->PreviewMclkFreq = SP0821_SERIAL_MCLK;
	Info->CaptureMclkFreq = SP0821_SERIAL_MCLK;
	Info->VideoMclkFreq = SP0821_SERIAL_MCLK;

	Info->PreviewWidth = SP0821_SERIAL_IMAGE_SENSOR_PV_WIDTH;
	Info->PreviewHeight = SP0821_SERIAL_IMAGE_SENSOR_PV_HEIGHT;
	Info->FullWidth = SP0821_SERIAL_IMAGE_SENSOR_FULL_WIDTH;
	Info->FullHeight = SP0821_SERIAL_IMAGE_SENSOR_FULL_HEIGHT;

	/* data format */
	Info->PreviewNormalDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
	Info->PreviewHMirrorDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
	Info->PreviewVMirrorDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
	Info->PreviewHVMirrorDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
	Info->CaptureDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;

	/* isp pclk invert switch */
	Info->PixelClkInv 			= KAL_FALSE;
	Info->PixelClkPolarity 		= POLARITY_LOW;

	/* HSYNC/VSYNC polarity */
	Info->HsyncPolarity = POLARITY_LOW; /* Actually high active when set POLARITY_LOW */
	Info->VsyncPolarity = POLARITY_LOW;

	Info->SensorAfSupport = KAL_FALSE;
	Info->SensorFlashSupport = KAL_FALSE;

	/* If IsSensorDriverCtrlMCLK is TRUE, then the MCLK turn on/off is controlled by sensor driver.*/
	Info->IsSensorDriverCtrlMclk = KAL_TRUE;
}

/*************************************************************************
* FUNCTION
*    SP0821SerialSensorFeatureCtrl
*
* DESCRIPTION
*    This function set sensor feature mode
*
* PARAMETERS
*    id: scenario id
*
* RETURNS
*    error code
*
* LOCAL AFFECTED
*
*************************************************************************/
MM_ERROR_CODE_ENUM SP0821_SERIALGetSerialSensorInfo(P_SERIAL_SENSOR_INFO_IN_STRUCT In,P_SERIAL_SENSOR_INFO_OUT_STRUCT Out)
{
	Out->para_1 = KAL_TRUE; 								/* SCK clock inverse */
	Out->para_2 = 4;										/* Cycle */
	
	if (In->ScenarioId == CAL_SCENARIO_CAMERA_STILL_CAPTURE)
	{
		Out->para_3 = SP0821_SERIAL_IMAGE_SENSOR_PV_WIDTH; 	/* Sensor capture data valid width */
		Out->para_4 = SP0821_SERIAL_IMAGE_SENSOR_PV_HEIGHT;	/* Sensor capture data valid height */
	}
	else
	{
		Out->para_3 = SP0821_SERIAL_IMAGE_SENSOR_FULL_WIDTH; 	/* Sensor preview data valid width */
		Out->para_4 = SP0821_SERIAL_IMAGE_SENSOR_FULL_HEIGHT; 	/* Sensor preview data valid height */
	}

	//Out->para_5  = 1;//lane number
	//Out->para_6  = KAL_FALSE;//DDR supprt
	//Out->para_7  = KAL_FALSE;//CRC support
	
	return MM_ERROR_NONE; 
}




/*************************************************************************
* FUNCTION
*   SP0821_SERIALPowerOn
*
* DESCRIPTION
*   This function apply the power on sequence and read the sensor ID to check if the I2C
*  communication can work or not.
*
* PARAMETERS
*   None
*
* RETURNS
*   Sensor id
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint32 SP0821_SERIALPowerOn(void)
{

  kal_uint32 SensorId = 0;
  
  CisModulePowerOn(SP0821_SERIALSensor.SensorIdx, KAL_TRUE);
  CameraSccbOpen(CAMERA_SCCB_SENSOR, SP0821_SERIAL_WRITE_ID_0,SP0821_SERIAL_I2C_ADDR_BITS, SP0821_SERIAL_I2C_DATA_BITS, SP0821_SERIAL_HW_I2C_SPEED);
  SP0821_SERIALSensor.sccb_opened = KAL_TRUE;
  kal_sleep_task(3);

  /* Enable the MCLK */
  ENABLE_CAMERA_CLOCK_OUTPUT_TO_CMOS;
  kal_sleep_task(2);
  
  CamPdnPinCtrl(0xFF, 1);
  kal_sleep_task(10);

#if defined(DUAL_CAMERA_SUPPORT)
	   SP0821_SERIALSensor.SensorIdx=camera_front_or_back;
#endif


   /* set sensors chip enable pin to low to activate SP0821 */
   CamPdnPinCtrl(SP0821_SERIALSensor.SensorIdx, 0);   //add 20121017
   
    kal_sleep_task(10);                                //add 20121017
   CamPdnPinCtrl(SP0821_SERIALSensor.SensorIdx, 1);   //need to check power on sequency //
   kal_sleep_task(10);
   
  /* Reset the sensor */
  CamRstPinCtrl(SP0821_SERIALSensor.SensorIdx, 1);
  kal_sleep_task(1);
  CamRstPinCtrl(SP0821_SERIALSensor.SensorIdx, 0);
  kal_sleep_task(4);
  CamRstPinCtrl(SP0821_SERIALSensor.SensorIdx, 1);
  kal_sleep_task(2);
  
   CameraSccbSetAddr(CAMERA_SCCB_SENSOR, SP0821_SERIAL_WRITE_ID_0);
   kal_sleep_task(5);
       
   SensorId = CamReadCmosSensor(0x02);
	   
    #ifndef WIN32
       dbg_print("SP0821_SERIALPowerOn  SensorId=%x\r\n", SensorId);
    #endif	       
       kal_prompt_trace(MOD_ENG,"SP0821_SERIALPowerOn SP0821SensorId = %x\r\n",SensorId);

  return SensorId;
}
/*************************************************************************
* FUNCTION
*   SP0821_SERIALPreview
*
* DESCRIPTION
*   This function is the most important functions of (Init, Preview & Capture). 
*   1. Apply preview setting, make sensor output preview resolution, e.g. 800x600 for 2M sensor.
*   2. Record video resolution, and set mode based on the isp operation mode.
*   3. Configure the grab window.
*
* PARAMETERS
*   Id, In, Out
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALPreview(CAL_SCENARIO_ENUM Id, P_IMAGE_SENSOR_SCENARIO_PARA_IN_STRUCT In, P_IMAGE_SENSOR_SCENARIO_PARA_OUT_STRUCT Out)
{

	if(0== In->BandingFreq)
	{
		SP0821_SERIAL_CAM_BANDING_50HZ =CAM_BANDING_50HZ;
	}
	else if(1== In->BandingFreq)
	{
		SP0821_SERIAL_CAM_BANDING_50HZ = CAM_BANDING_60HZ;
	}
	SP0821_SERIAL_CAM_nightmode = In->NightMode;
	SP0821_SERIALPvSetting();

	switch (Id)
	{
	case CAL_SCENARIO_VIDEO:
		video_mode = KAL_TRUE;
		Out->WaitStableFrameNum = 3;
		break;
	default:

		video_mode = KAL_FALSE;
		Out->WaitStableFrameNum = 3;
		break;
	}
  
	//SP0821_SERIALSetMirror(In->ImageMirror);

	SP0821_SERIALAeEnable(KAL_TRUE);
	SP0821_SERIALAwbEnable(KAL_TRUE);
if(RD_Tcard_OK == KAL_FALSE)
		{
	SP0821_SERIALNightMode(video_mode,SP0821_SERIAL_CAM_BANDING_50HZ,SP0821_SERIAL_CAM_nightmode);
}
	Out->GrabStartX = SP0821_SERIAL_PV_GRAB_START_X;
	Out->GrabStartY = SP0821_SERIAL_PV_GRAB_START_Y;
	Out->ExposureWindowWidth = SP0821_SERIAL_PV_GRAB_WIDTH;
	Out->ExposureWindowHeight = SP0821_SERIAL_PV_GRAB_HEIGHT;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALCapture
*
* DESCRIPTION
*   This function is the most important functions of (Init, Preview & Capture). 
*   1. Apply capture setting when capture size greatter then preview size, make sensor output 
*     full size, e.g. 1600x1200 for 2M sensor.
*   2. Increase the dummy pixels or derease pixel clock based on the digital zoom factor and
*    interpolation times.
*   3. Re-Calculate the shutter and sensor gain, to make the exposure value is same with preview
*   4. Configure the grab window based on sensor output.
*
* PARAMETERS
*   Id, In, Out
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALCapture(CAL_SCENARIO_ENUM Id, P_IMAGE_SENSOR_SCENARIO_PARA_IN_STRUCT In, P_IMAGE_SENSOR_SCENARIO_PARA_OUT_STRUCT Out)
{
	SP0821_SERIALCapSetting();
	
	Out->WaitStableFrameNum = SP0821_SERIAL_CAPTURE_DELAY_FRAME;

	Out->GrabStartX = SP0821_SERIAL_FULL_GRAB_START_X;
	Out->GrabStartY = SP0821_SERIAL_FULL_GRAB_START_Y;
	Out->ExposureWindowWidth = SP0821_SERIAL_FULL_GRAB_WIDTH;
	Out->ExposureWindowHeight = SP0821_SERIAL_FULL_GRAB_HEIGHT;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALDetectSensorId
*
* DESCRIPTION
*   This function detect sensor id
*
* PARAMETERS
*   None
*
* RETURNS
*   Sensor id
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint32 SP0821_SERIALDetectSensorId(void)
{
    MM_ERROR_CODE_ENUM SP0821_SERIALSensorClose(void);
    kal_uint32 SensorId;
  	IMAGE_SENSOR_INDEX_ENUM AnotherSensorIdx;
	kal_int8 i, j;

	if (IMAGE_SENSOR_MAIN == SP0821_SERIALSensor.SensorIdx)
	{
		AnotherSensorIdx = IMAGE_SENSOR_SUB;
	}
	else
	{
		AnotherSensorIdx = IMAGE_SENSOR_MAIN;
	}
for (i = 1; i >= 0; i--)
{
	for (j = 1; j >= 0; j--)
	{
	CamRstPinCtrl(AnotherSensorIdx, i);
	CamPdnPinCtrl(AnotherSensorIdx, j);
      SensorId = SP0821_SERIALPowerOn();
      SP0821_SERIALSensorClose();
      if (SP0821_SERIAL_SENSOR_ID == SensorId)
      {
        return SP0821_SERIAL_SENSOR_ID;
      }
    }
  }
  return MM_ERROR_SENSOR_READ_ID_FAIL;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALInitOperationPara
*
* DESCRIPTION
*   This function set sensor operation para
*
* PARAMETERS
*   Para
*
* RETURNS
*   None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0821_SERIALInitOperationPara(P_IMAGE_SENSOR_GET_INIT_OPERATION_PARA_STRUCT Para)
{
  Para->CaptureDelayFrame = 0; /* use WaitStableFrameNum instead of this */
  Para->PreviewDelayFrame = SP0821_SERIAL_PREVIEW_DELAY_FRAME;
  Para->PreviewDisplayWaitFrame = SP0821_SERIAL_FIRST_PREVIEW_DELAY_FRAME;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSensorOpen
*
* DESCRIPTION
*   This function read sensor id and init sensor
*
* PARAMETERS
*   None
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/

 MM_ERROR_CODE_ENUM SP0821_SERIALSensorOpen(void)
{
  if (SP0821_SERIALPowerOn() != SP0821_SERIAL_SENSOR_ID)
  {
    return MM_ERROR_SENSOR_READ_ID_FAIL;
  }
//  GPIO_ModeSetup(SP0821_PCLK_PIN,2);   	//CMPCLK	
//  GPIO_ModeSetup(SP0821_DATA0_PIN,2);   	//Data0


#ifdef SP0821_LOAD_FROM_T_FLASH
    //??????????????sp0821_sd ???,??????
	//??????,?????????_s_fmt??
if (1==SP0821_Initialize_from_T_Flash())
	RD_Tcard_OK = KAL_TRUE;
else
	
#endif

  SP0821_SERIALInitialSetting(); /* apply the sensor initial setting */
  /* default setting */
  SP0821_SERIALSensor.BypassAe = KAL_FALSE;
  SP0821_SERIALSensor.BypassAwb = KAL_FALSE;
  SP0821_SERIALSensor.PvMode = KAL_TRUE;
  SP0821_SERIALSensor.BandingFreq = CAM_BANDING_50HZ;
  SP0821_SERIALSensor.InternalClock = 0;
  SP0821_SERIALSensor.Shutter = 1;
  //SP0821_SERIALSensor.Gain = 0x40;
  SP0821_SERIALSensor.FrameLength = 0;
  SP0821_SERIALSensor.LineLength = 0;
  
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSensorFeatureCtrl
*
* DESCRIPTION
*   This function set sensor feature mode
*
* PARAMETERS
*   Id: scenario id
*   In: input parameter
*   Out: output parameter
*   OutLen: output parameter length
*   RealOutLen: real output parameter length
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
 MM_ERROR_CODE_ENUM SP0821_SERIALSensorFeatureCtrl(kal_uint32 Id, void *In, void *Out, kal_uint32 OutLen, kal_uint32 *RealOutLen)
{
  MM_ERROR_CODE_ENUM ErrCode = MM_ERROR_NONE;
  
  if (Id >= CAL_FEATURE_WEBCAM_BEGIN && Id <= CAL_FEATURE_WEBCAM_END)
  {
    return SP0821_SERIALWebcamFeatureCtrl(Id, In, Out, OutLen, RealOutLen);
  }
  switch (Id)
  {
  /* query and set series */
  case CAL_FEATURE_CAMERA_BRIGHTNESS:
  case CAL_FEATURE_CAMERA_EV_VALUE:
  	if(RD_Tcard_OK == KAL_FALSE)
		{
    ErrCode = SP0821_SERIALEv(In, Out);
  		}
    break;
  case CAL_FEATURE_CAMERA_CONTRAST:
  	if(RD_Tcard_OK == KAL_FALSE)
		{
    ErrCode = SP0821_SERIALContrast(In, Out);
  		}
    break;
  case CAL_FEATURE_CAMERA_SATURATION:
  	if(RD_Tcard_OK == KAL_FALSE)
		{
    ErrCode = SP0821_SERIALSaturation(In, Out);
  		}
    break;
  case CAL_FEATURE_CAMERA_SHARPNESS:
  	if(RD_Tcard_OK == KAL_FALSE)
		{
    ErrCode = SP0821_SERIALSharpness(In, Out);
  		}
    break;
  case CAL_FEATURE_CAMERA_WB:
  	if(RD_Tcard_OK == KAL_FALSE)
		{
    ErrCode = SP0821_SERIALWb(In, Out);
  		}
    break;
  case CAL_FEATURE_CAMERA_IMAGE_EFFECT:
  	if(RD_Tcard_OK == KAL_FALSE)
		{
    ErrCode = SP0821_SERIALEffect(In, Out);
  		}
    break;
  case CAL_FEATURE_CAMERA_STILL_CAPTURE_SIZE:
    ErrCode = SP0821_SERIALStillCaptureSize(In, Out);
    break;
  case CAL_FEATURE_CAMERA_BANDING_FREQ:
  	if(RD_Tcard_OK == KAL_FALSE)
		{
    ErrCode = ErrCode = SP0821_SERIALBanding(In, Out);
  		}
    break;
  case CAL_FEATURE_CAMERA_SCENE_MODE:
  	if(RD_Tcard_OK == KAL_FALSE)
		{
    ErrCode = SP0821_SERIALSceneMode(KAL_TRUE, In, Out);
  		}
    break;
  case CAL_FEATURE_CAMERA_VIDEO_SCENE_MODE:
  	if(RD_Tcard_OK == KAL_FALSE)
		{
    ErrCode = SP0821_SERIALSceneMode(KAL_FALSE, In, Out);
  		}
    break;
  case CAL_FEATURE_CAMERA_FLASH_MODE:
  case CAL_FEATURE_CAMERA_HUE:
  case CAL_FEATURE_CAMERA_GAMMA:
    ErrCode = MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    break;
  
  /* get info series */
  case IMAGE_SENSOR_FEATURE_GET_SENSOR_INFO:
    SP0821_SERIALGetSensorInfo(Out);
    break;
  case IMAGE_SENSOR_FEATURE_GET_SENSOR_ID:
    ((P_IMAGE_SENSOR_COMM_DATA_STRUCT)Out)->FeatureValue = SP0821_SERIALDetectSensorId();
    break;
  case IMAGE_SENSOR_FEATURE_GET_SENSOR_FRAME_RATE:
    ((P_IMAGE_SENSOR_COMM_DATA_STRUCT)Out)->FeatureValue = SP0821_SERIALSensor.MaxFrameRate;
    break;
  case IMAGE_SENSOR_FEATURE_GET_INIT_OPERATION_PARA:
    SP0821_SERIALInitOperationPara(Out);
    break;
  case IMAGE_SENSOR_FEATURE_GET_HW_DEPENDENT_SETTING:
    CamGetHWInfo(SP0821_SERIALSensor.SensorIdx, Out);
    break;
  
  /* Set para series */
  case IMAGE_SENSOR_FEATURE_SET_SENSOR_POWER_DOWN:
   // SP0821_SERIALPowerDown();
    break;
  case IMAGE_SENSOR_FEATURE_SET_NVRAM_SENSOR_INFO:
    SP0821_SERIALSensor.NvramData = &(((nvram_camera_para_struct *)In)->SENSOR);
    break;
  case IMAGE_SENSOR_FEATURE_SET_CAMERA_SOURCE:
    SP0821_SERIALSensor.SensorIdx = ((P_IMAGE_SENSOR_SET_CAMERA_SOURCE_STRUCT)In)->ImageSensorIdx;
    break;
  case IMAGE_SENSOR_FEATURE_CTRL_NIGHTMODE: /* move to preview */
    break;
  case IMAGE_SENSOR_FEATURE_SET_AE_BYPASS:
    SP0821_SERIALSensor.BypassAe = *(kal_bool *)In;
    SP0821_SERIALAeEnable(SP0821_SERIALSensor.BypassAe ? KAL_FALSE : KAL_TRUE);
    break;
  case IMAGE_SENSOR_FEATURE_SET_AWB_BYPASS:
    SP0821_SERIALSensor.BypassAwb = *(kal_bool *)In;
    SP0821_SERIALAwbEnable(SP0821_SERIALSensor.BypassAwb ? KAL_FALSE : KAL_TRUE);
    break;
case IMAGE_SENSOR_FEATURE_GET_SERIAL_SENSOR_INFO:
    SP0821_SERIALGetSerialSensorInfo(In, Out);
     break;
  default:
    ErrCode = MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    break;
  }
  return ErrCode;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSensorCtrl
*
* DESCRIPTION
*   This function set sensor scenario mode
*
* PARAMETERS
*   Id: scenario id
*   In/Out: parameter
*   OutLen: out parameter length
*   RealOutLen: real out parameter length
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
 MM_ERROR_CODE_ENUM SP0821_SERIALSensorCtrl(CAL_SCENARIO_ENUM Id, void *In, void *Out, kal_uint32 OutLen, kal_uint32 *RealOutLen)
{
  switch (Id)
  {
  case CAL_SCENARIO_CAMERA_PREVIEW:
  case CAL_SCENARIO_VIDEO:
  case CAL_SCENARIO_WEBCAM_PREVIEW:
  case CAL_SCENARIO_WEBCAM_CAPTURE:
    SP0821_SERIALPreview(Id, In, Out);
    break;
  case CAL_SCENARIO_CAMERA_STILL_CAPTURE:
    SP0821_SERIALCapture(Id, In, Out);
    break;
  default:
    break;
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSensorClose
*
* DESCRIPTION
*   This function is to turn off sensor module power.
*
* PARAMETERS
*   None
*
* RETURNS
*   Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
 MM_ERROR_CODE_ENUM SP0821_SERIALSensorClose(void)
{
   #if defined(DUAL_CAMERA_SUPPORT)
        SP0821_SERIALSensor.SensorIdx=camera_front_or_back;
   #endif

	/* Set Low to MCLK */
	DISABLE_CAMERA_CLOCK_OUTPUT_TO_CMOS;

	CisModulePowerOn(SP0821_SERIALSensor.SensorIdx, KAL_FALSE);
	kal_sleep_task(2);
	CamPdnPinCtrl(0xFF, 0);

	SP0821_SERIALSensor.sccb_opened = KAL_FALSE;
	CameraSccbClose(CAMERA_SCCB_SENSOR);
//	GPIO_ModeSetup(SP0821_PCLK_PIN,1);   	//CMPCLK	
//	GPIO_ModeSetup(SP0821_DATA0_PIN,1);   	//Data0
	return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*   SP0821_SERIALSensorFunc
*
* DESCRIPTION
*   This function get sensor function pointer
*
* PARAMETERS
*   Sensor function pointer
*
* RETURNS
*   Error code
*
* GLOBALS AFFECTED
*
*************************************************************************/
MM_ERROR_CODE_ENUM SP0821_SERIALSensorFunc(P_IMAGE_SENSOR_FUNCTION_STRUCT *pfSensorFunc)
{
  static IMAGE_SENSOR_FUNCTION_STRUCT ImageSensorFuncSP0821_SERIAL =
  {
    SP0821_SERIALSensorOpen,
    SP0821_SERIALSensorFeatureCtrl,
    SP0821_SERIALSensorCtrl,
    SP0821_SERIALSensorClose,
  };
  
  *pfSensorFunc = &ImageSensorFuncSP0821_SERIAL;
  
  return MM_ERROR_NONE;
}



